/***************************************************************************
 *  Copyright (C) 2009 by Anton R. <commanderkyle@gmail.com>
 *
 *  This file is a part of QAquarelle project.
 *
 *  QAquarelle is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  QAquarelle is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with QAquarelle.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

#include "commdefs.h"
#include "commtypes.h"
#include "refcounter.h"

#include <QList>
#include <QHash>
#include <QXmlDefaultHandler>

//#ifdef QT_OPENGL_LIB
#   include "../../../glew/include/GL/glew.h"
#   include "iPaperSwitch.h"


/**
 * Handler for xml-elements from papers list.
 */
class CQXmlHandler_Paper : public QXmlDefaultHandler {
    IOpenGLHelper  * m_Helper;

    sPaper         * cur_paper;
    QList<sPaper*>   cur_list;

    /**
     * Format of the input file.
     */
    int  format;
    bool open;
public:

     CQXmlHandler_Paper (IOpenGLHelper * helper);
    ~CQXmlHandler_Paper (void);

    /**
     * Returns the list of all loaded papers.
     */
    QList<sPaper*> * papers (void) {
        return & cur_list;
    }

    /**
     * Delete all loaded data.
     */
    void clear (void);

    bool startElement (const QString &namespaceURI, const QString &localName,
                       const QString &qName, const QXmlAttributes &attributes);

    bool endElement (const QString &namespaceURI, const QString &localName,
                     const QString &qName);

    bool characters (const QString &str);

    bool fatalError (const QXmlParseException &exception);

    QString errorString (void) const;
};
