/***************************************************************************
 *   Copyright (C) 2009 by Anton R. <commanderkyle@gmail.com>              *
 *                                                                         *
 *   This file is a part of QAquarelle project.                            *
 *                                                                         *
 *   QAquarelle is free software; you can redistribute it and/or modify    *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ICONWIDGET_H
#define ICONWIDGET_H
#include "commtypes.h"
#include "commdefs.h"
#include "refcounter.h"

#include <QWidget>
#include <QImage>
#include <QPainter>

class IconWidget : public QWidget {
public:
    IconWidget (QWidget * parent) : QWidget (parent) {
        m_HasIcon = FALSE;

        setAutoFillBackground (FALSE);
    }

public slots:
    void iconChanged (QImage * image) {
        if (image) {
            m_HasIcon = TRUE;
            m_Icon = image->copy (image->rect ());
        } else {
            m_HasIcon = FALSE;
        }

        update ();
    }

protected:
    QImage m_Icon;
    bool   m_HasIcon;

    void paintEvent (QPaintEvent * event) {
        Q_UNUSED (event);
        QPainter painter (this);
        if (m_HasIcon) {
            painter.drawImage (rect (), m_Icon);
        } else {
            painter.fillRect (rect (), QColor (0, 0, 0, 0));
        }
    }
};

#endif // ICONWIDGET_H
