#include "skin.h"

ISkin * g_fac_SPAWN_SKIN (QString path) {
    return new Skin (path);
}

Skin::Skin (QString path) {
    m_Id = ISpawnedObject::allocateId ();
    setRoot (path);
}

Skin::~Skin (void) {
    clean ();
}

void Skin::clean (void) {
    // Remove all entries.
    while (m_HashedImages.size ()) {
        QHash<QString, QImage*>::iterator i = m_HashedImages.begin ();

        delete i.value ();
        m_HashedImages.erase (i);
    }
}

void Skin::setRoot (QString path) {
    clean ();
    m_SkinRoot = QDir (path);
}

QString Skin::pixmapPathByName (QString name) const {
    return m_SkinRoot.absoluteFilePath (name);
}

QImage * Skin::pixmapByName (QString name) {
    QImage * ret = NULL;

    if (!m_HashedImages.contains (name)) {
        // Store a new value on hash.
        ret = new QImage (m_SkinRoot.absoluteFilePath (name));
        m_HashedImages.insert (name, ret);
    } else {
        ret = m_HashedImages[name];
    }

    return ret;
}
